if($Pref::ChinookAscendingPower $= "")
	$Pref::ChinookAscendingPower = 1;

if($Pref::ChinookLoopDelay $= "")
	$Pref::ChinookLoopDelay = 0;

datablock AudioDescription(AudioRotorLooping3D)
{
	volume = 1;
	isLooping = 1;
	is3D = 1;
	ReferenceDistance = 40;
	maxDistance = 500;
	coneInsideAngle = 360;
	coneOutsideAngle = 360;
	coneOutsideVolume = 1;
	coneVector = "-0.000151468 0.0246369 0.999696";
	loopCount = -1;
	minLoopGap = 0;
	maxLoopGap = 0;
	type = 2;
};

datablock AudioProfile(ChinookRotorsSound)
{
	filename = "./blades_near.wav";
	description = AudioDefaultLooping3d;
	preload = 1;
};

datablock AudioProfile(ChinookRotorDistantSound)
{
	filename  = "./blades_far.wav";
	description = AudioRotorLooping3D;
	preload = 1;
};

function serverCMDchinookhelp(%client)
{
	messageClient(%client, '', "\c7----------------");
	messageClient(%client, '', "\c2Controls");
	messageClient(%client, '', "\c2Jump Key: \c6Ascend/Descend");
	messageClient(%client, '', "\c2Light Key: \c6Switch between ascending/descending");
	messageClient(%client, '', "\c2Previous Seat Key: \c6Lower Loading Ramp");
	messageClient(%client, '', "\c2Next Seat Key: \c6Switch Seat");
	messageClient(%client, '', "\c2Clear Brick Key: \c6Activate Altitude Control");
	messageClient(%client, '', "\c2Plant Brick Key: \c6Activate Stabilizer");
	messageClient(%client, '', "\c2Shift Brick Away Key: \c6Raise auto-altitude level");
	messageClient(%client, '', "\c2Shift Brick Back Key: \c6Lower auto-altitude level");
}

function serverCMDch(%client)
{
	serverCMDchinookhelp(%client);
}

datablock FlyingVehicleData(ChinookVehicle)
{
	category = "Vehicles";
	displayName = "";
	shapeFile = "./Chinook.dts";
	emap = 1;
	mass = 400;
	drag = 1;
	density = 0.7;
	maxDamage = 225;
	destroyedLevel = 225;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20;
	collDamageMultiplier = 0.02;
	minMountDist = 3;   
	numMountPoints = 8;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";
	mountThread[5] = "sit";
	mountThread[6] = "sit";
	mountThread[7] = "sit";
	lookUpLimit = 0.50;
	lookDownLimit = 0.50;
	jetForce = 10000;
	jetEnergyDrain = 8;
	minJetEnergy = 10000;
	massCenter = "0 0 0";
	bodyFriction = 0.9;
	bodyRestitution = 0.1;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10;
	minRollSpeed = 0;
	maxSteeringAngle = 0.785;
	maxDrag = 40;
	minDrag = 50;
	integration = 4;
	collisionTol = 0.1;
	contactTol = 0.1;
	cameraRoll = 0;
	cameraMaxDist = 25;
	cameraLag = 0;
	cameraDecay = 0;
	cameraOffset = 12;
	cameraTilt = 0;
	triggerDustHeight = 3;
	dustHeight = 1;
	numDmgEmitterAreas = 2;
	damageEmitter[0] = vehicleBurnEmitter;
	damageEmitterOffset[0] = "0 3 3 ";
	damageLevelTolerance[0] = 1;
	damageEmitter[1] = vehicleBurnEmitter;
	damageEmitterOffset[1] = "5 0 1 ";
	damageLevelTolerance[1] = 1;
	splashFreqMod = 300;
	splashVelEpsilon = 0.50;
	exitSplashSoundVelocity = 2;
	softSplashSoundVelocity = 1;
	mediumSplashSoundVelocity = 2;
	hardSplashSoundVelocity = 3;
	collDamageThresholdVel = 20;
	collDamageMultiplier = 0.05;
	uiName = "Chinook";
	rideAble = 1;
	paintable = 1;
	maneuveringForce = 6500;
	horizontalSurfaceForce = 20;
	verticalSurfaceForce = 2000;
	autoInputDamping = 0.95;
	steeringForce = 1000;
	steeringRollForce = 0;
	rollForce = 10;
	autoAngularForce = 600;
	rotationalDrag = 6;
	autoLinearForce = 100;
	maxAutoSpeed = 6;
	hoverHeight = 0;
	createHoverHeight = 0;
	minTrailSpeed = 1;
	vertThrustMultiple = 1;
	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;
	burnTime = 5000;
	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;
	minRunOverSpeed = 5;
	runOverDamageScale = 5;
	runOverPushScale = 1.2;
	minLookAngle = 0;
	maxLookAngle = 1.5708;
	protectPassengersBurn = 1;
	protectPassengersRadius = 1;
	protectPassengersDirect = 1;
};

function Vehicle::DeathSpin(%vehicle)
{
	cancel(%vehicle.spinSched);
	%vehicle.setAngularVelocity(0 SPC 0 SPC getRandom(3, 4));
	%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale(getRandom(-10, 10) SPC getRandom(-10, 10) SPC getRandom(-1, -3), %vehicle.getDataBlock().mass) );
	%vehicle.spinSched = %vehicle.schedule(33, deathSpin);
}

datablock DebrisData(ChinookDebris)
{
	emitters = "jeepDebrisTrailEmitter";
	shapeFile = "./Chinook.dts";
	lifetime = 5;
	minSpinSpeed = -1000;
	maxSpinSpeed = 1000;
	elasticity = 0.8;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = 1;
	snapOnMaxBounce = 0;
	fade = 1;
	gravModifier = 2;
};

datablock ShapeBaseImageData(ChinookEngineEmitterImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 0;
	stateName[0] = "Ready";
	stateTransitionOnTimeout[0] = "FireA";
	stateTimeoutValue[0] = 0;

	stateName[1] = "FireA";
	stateTransitionOnTimeout[1] = "Ready";
	stateWaitForTimeout[1] = True;
	stateTimeoutValue[1] = 4;
	stateEmitter[1] = rocketLauncherSmokeEmitter;
	stateEmitterTime[1] = 4;
};

datablock ShapeBaseImageData(ChinookEngineDamageImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;
	mountPoint = 0;
	stateName[0] = "Ready";
	stateTransitionOnTimeout[0] = "FireA";
	stateTimeoutValue[0] = 0.0;
	
	stateName[1] = "FireA";
	stateTransitionOnTimeout[1] = "Ready";
	stateWaitForTimeout[1] = True;
	stateTimeoutValue[1] = 4.00;
	stateEmitter[1] = jeepDebrisTrailEmitter;
	stateEmitterTime[1] = 4.00;
};

datablock PlayerData(ChinookEnginePlayer : TankTurretPlayer)
{
   shapeFile = "base/data/shapes/empty.dts";
   uiName = "";
   boundingBox = "0 0 0";
   crouchBoundingBox = "0 0 0";
};

function ChinookVehicle::onAdd(%this, %obj)
{
	%obj.RotateBladeLoop();
	%obj.ChinookLoop();
	%obj.playAudio(0, ChinookRotorsSound);
	%obj.playAudio(1, ChinookRotorDistantSound);
	%obj.ascendMulti = 1;
	%t = new AIPlayer()
	{
		dataBlock = ChinookEnginePlayer;
		isEngine = true;
		master = %obj;
		type = "EngineL";
		minigame = %obj.minigame;
	};
	if(isObject(%t))
	{
		MissionCleanup.add(%t);
		%obj.mountObject(%t, 8);
		%obj.EngineLeft = %t;
		%t.mountImage(ChinookEngineEmitterImage, 0);
		%t.schedule(10, rigChinookStuff);
	}

	%t = new AIPlayer()
	{
		dataBlock = ChinookEnginePlayer;
		isEngine = true;
		master = %obj;
		type = "EngineR";
		minigame = %obj.minigame;
	};
	if(isObject(%t))
	{
		MissionCleanup.add(%t);
		%obj.mountObject(%t, 9);
		%obj.EngineRight = %t;
		%t.mountImage(ChinookEngineEmitterImage, 0);
		%t.schedule(10, rigChinookStuff);
	}
	//if(%obj.LoadingBayMode == 0)
	//	%obj.LoadingBayMode = 1;
}

function ChinookEnginePlayer::Damage(%data, %obj, %sourceObject, %position, %damage, %damageType)
{
	if(!$Pref::ChinookDamageEnabled)
		return;
	if(%obj.isEngine)
		%damage *= 2;
	if(%obj.getDamageLevel() + %damage > 100)
		%damage = 100 - %obj.getDamageLevel();
	Parent::Damage(%data, %obj, %sourceObject, %position, %damage, %damageType);
	if(%obj.getDamageLevel() >= 100)
	{
		%obj.unMountImage(0);
		%obj.schedule(33, mountImage, ChinookEngineDamageImage, 0);
		if(%obj.isEngine && !%obj.failed)
		{
			%obj.failed = true;
			%obj.master.engineFailures++;
		}
	}
}

function Player::rigChinookStuff(%obj)
{
	if(!isObject(%obj))
		return;
	%parent = %obj.getObjectMount();
	if(!isObject(%parent))
		return;
	%obj.spawnBrick = %parent.spawnBrick;
	%obj.brickGroup = %parent.brickGroup;
}

function ChinookVehicle::onRemove(%this, %obj)
{
	if(isObject(%obj.EngineLeft))
		%obj.EngineLeft.delete();
	if(isObject(%obj.EngineRight))
		%obj.EngineRight.delete();
}

function Vehicle::RotateBladeLoop(%vehicle)
{
	cancel(%vehicle.heliLoop);
	%vehicle.playThread(0, "ambient");
	%vehicle.heliLoop = %vehicle.schedule(300, RotateBladeLoop);
}

function Vehicle::enableAltitudeControl(%vehicle)
{
	%vehicle.maintainAltitudeLevel = 50;
	%vehicle.maintainAltitudeLoopActive = true;
	%vehicle.maintainAltitude();
}

function Vehicle::disableAltitudeControl(%vehicle)
{
	%vehicle.maintainAltitudeLoopActive = false;
}

function Vehicle::ChinookLoop(%vehicle)
{
	cancel(%vehicle.loopSc);

	if(isObject(%client = %vehicle.getMountedObject(0).client) && isObject(%client.player.getControlObject()))//if(isObject(%client = %vehicle.getMountedObject(0).client))
		%client.pushChinookHUD(%vehicle);
	if(%vehicle.stabilizerActive && %vehicle.getDamagePercent() < 1)
		%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale(vectorScale(%vehicle.getVelocity(), -0.3), %vehicle.getDataBlock().mass) );
	for(%i = 0; %i < %vehicle.engineFailures; %i++)
	{
		%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale(getRandom(-2, 2) SPC getRandom(-2, 2) SPC getRandom(-1, -3), %vehicle.getDataBlock().mass) );
		%vehicle.stabilizerActive = false;
		%vehicle.disableAltitudeControl();
		if(%vehicle.engineFailures > 1)
			ChinookVehicle.damage(%vehicle, %vehicle, %vehicle.getPosition(), getRandom(0, 5), 0, true);
	}

	%vehicle.loopSc = %vehicle.schedule(100 + $Pref::ChinookLoopDelay, ChinookLoop);
}

function resetChinook()
{
	exec("./server.cs");
}


function Vehicle::maintainAltitude(%vehicle)
{
	%altitude = getWord(%vehicle.getPosition(), 2);
	if(%altitude > %vehicle.maintainAltitudeLevel)
		%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale("0 0" SPC (-3 * $Pref::ChinookAscendingPower), %vehicle.getDataBlock().mass) );
	else
		%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale("0 0" SPC (3 * $Pref::ChinookAscendingPower), %vehicle.getDataBlock().mass) );
	cancel(%vehicle.maintainAltitudeLoop);
	if(%vehicle.maintainAltitudeLoopActive) //&& isObject(%vehicle.getControllingClient()))
		%vehicle.maintainAltitudeLoop = %vehicle.schedule(100 + $Pref::ChinookLoopDelay, maintainAltitude);
	else
		%vehicle.disableAltitudeControl();
}

function Vehicle::ascendLoop(%vehicle)
{
	cancel(%vehicle.altitudeLoop);
	%multi = vectorLen(getWord(%vehicle.getVelocity(), 0) SPC getWord(%vehicle.getVelocity(), 1) SPC 0) / 20;
	if(%multi < 1.0)
		%multi = 1.0;
	if(%multi > 1.5)
		%multi = 1.5;
	%vehicle.applyImpulse(%vehicle.getPosition(), vectorScale(vectorScale(vectorScale("0 0" SPC (%multi * %vehicle.ascendMulti), %vehicle.getDataBlock().mass), %multi), $Pref::ChinookAscendingPower));
	if(isObject(%vehicle.getControllingClient()))
		%vehicle.altitudeLoop = %vehicle.schedule(33 + $Pref::ChinookLoopDelay, ascendLoop);
}

function ChinookVehicle::onTrigger(%this, %vehicle, %num, %val)
{
	if(%num == 2)
	{
		if(%val)
		{
			%vehicle.disableAltitudeControl();
			%vehicle.ascendLoop();
		}
		else
			cancel(%vehicle.altitudeLoop);
	}
}

function ChinookVehicle::Damage(%this, %obj, %sourceObject, %position, %damage, %damageType, %bool)
{
	if(isObject(%client = %obj.getControllingClient()))
		%client.pushChinookHUD();
	%multi = (mPow((%damage / 20.8), (%damage / 10))) / 41.6;
	if(%multi > 1 || %bool)
		%multi = 1;
	
	%damage *= %multi;
	Parent::Damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
	if(%obj.getDamagePercent() >= 1)
	{
		cancel(%vehicle.heliLoop);
		%obj.DeathSpin();
	}
}

function GameConnection::pushChinookHUD(%client, %vehicle)
{
	if(!isObject(%client) || !isObject(%vehicle))
		return;

	if(%vehicle.getDamagePercent() >= 1)
	{
		%client.centerPrint("<font:impact:34>EJECT!", 1);
		%client.bottomPrint("<just:center>Critical Failure! Eject!", 1);
		return;
	}

	%string = "";
	%alt = getWord(%vehicle.getPosition(), 2);
	%string = %string @ "<just:left>" @ (%vehicle.maintainAltitudeLoopActive ? "\c2" : "\c7") @ "[Altitude CTRL]";
	%string = %string SPC (%vehicle.stabilizerActive ? "\c3" : "\c7") @ "[STAB]";
	%string = %string SPC (%vehicle.engineFailures > 0 ? "\c0" : "\c7") @ "[ENG]";
	%string = %string SPC (%vehicle.ascendMulti > 0 ? "\c4[^]" : "\c5[v]");
	
	%color = "\c4";
	if(100 - mCeil(%vehicle.getDamagePercent() * 100) < 75)
		%color = "\c3";

	if(100 - mCeil(%vehicle.getDamagePercent() * 100) < 45)
		%color = "\c0";
	%string = %string @ "\c6      Hull:" @ %color SPC 100 - mCeil(%vehicle.getDamagePercent() * 100) @ "%";
	
	%color = "\c4";
	if(%vehicle.maintainAltitudeLoopActive)
	{
		if(%dif = mAbs(%alt - %vehicle.maintainAltitudeLevel) > 5)
			%color = "\c3";
	
		if(%dif = mAbs(%alt - %vehicle.maintainAltitudeLevel) > 15)
			%color = "\c0";
	}
	%string = %string @ "<just:right>\c6Altitude:" SPC %color @ mCeil(%alt);
	if(%vehicle.maintainAltitudeLoopActive)
		%string = %string @ "\c1|" @ %vehicle.maintainAltitudeLevel;
	%string = %string SPC "<br><font:Palatino Linotype:19><just:center>\c7Type /chinookhelp or /ch for instructions";
	%client.bottomPrint(%string, 1);
}

function Vehicle::chinook_handleStab(%vehicle, %client)
{
	if(!%vehicle.stabilizerActive)
		%vehicle.stabilizerActive = true;
	else
		%vehicle.stabilizerActive = false;
	if(isObject(%client))
		%client.pushChinookHUD();
}

package ChinookControls
{
	function Vehicle::onDriverLeave(%vehicle, %player)
	{
		Parent::onDriverLeave(%vehicle, %player);
		if(%vehicle.getDatablock().getName() $= "ChinookVehicle")
			if(%vehicle.getDamagePercent() >= 1)
				%player.schedule(33, setVelocity, "0 0 40");
	}

	function serverCMDLight(%client)
	{	
		if(!isObject(%client) || !isObject(%p = %client.player))
			return;
		//if(isObject(%vehicle = %client.player.getObjectMount()) && %vehicle.getDatablock().getName() $= "ChinookVehicle")
		if(isObject(%vehicle = %p.getControlObject()) && %veh = %p.getControlObject().getDatablock().getName() $= "ChinookVehicle")
		{
			if(%vehicle.ascendMulti == 1)
				%vehicle.ascendMulti = -1;
			else
				%vehicle.ascendMulti = 1;
			%client.pushChinookHUD();
		}
		else
			Parent::serverCMDLight(%client);
	}

	function serverCMDPrevSeat(%client)
	{
		if(!isObject(%client) || !isObject(%p = %client.player))
			return;
		if(isObject(%vehicle = %p.getControlObject()) && %veh = %p.getControlObject().getDatablock().getName() $= "ChinookVehicle")
		{
			if(%vehicle.getControllingClient() == %client)
			{
				switch(%vehicle.LoadingBayMode)
				{
					case 0:
						%vehicle.playThread(2, "open");
						%vehicle.LoadingBayMode++;
					case 1:
						%vehicle.playThread(2, "close");
						%vehicle.LoadingBayMode++;
				}
				if(%vehicle.LoadingBayMode > 1)
					%vehicle.LoadingBayMode = 0;
			}
		}
		else
			Parent::serverCMDPrevSeat(%client);
	}
	
	function serverCMDPlantBrick(%client, %a, %b, %c, %d, %e, %f)
	{
		if(!isObject(%client) || !isObject(%p = %client.player))
			return;
		if(isObject(%vehicle = %p.getControlObject()) && %veh = %p.getControlObject().getDatablock().getName() $= "ChinookVehicle")
		//if(isObject(%vehicle = %client.player.getObjectMount()) && %vehicle.getDatablock().getName() $= "ChinookVehicle")
			%vehicle.chinook_handleStab(%client);
		Parent::serverCMDPlantBrick(%client, %a, %b, %c, %d, %e, %f);
	}
	
	function serverCMDCancelBrick(%client)
	{
		if(!isObject(%client) || !isObject(%p = %client.player))
			return;
		if(isObject(%vehicle = %p.getControlObject()) && %vehicle.getDatablock().getName() $= "ChinookVehicle")
		{
			if(!%vehicle.maintainAltitudeLoopActive)
				%vehicle.enableAltitudeControl();
			else
				%vehicle.disableAltitudeControl();
			%client.pushChinookHUD();
		}
		Parent::serverCMDCancelBrick(%client);
	}
	
	function serverCMDShiftBrick(%client, %a, %b, %c, %d, %e, %f)
	{
		if(!isObject(%client) || !isObject(%p = %client.player))
			return;
		if(isObject(%vehicle = %p.getControlObject()) && %veh = %p.getControlObject().getDatablock().getName() $= "ChinookVehicle")
		//if(isObject(%vehicle = %client.player.getObjectMount()) && %vehicle.getDatablock().getName() $= "ChinookVehicle")
		{
			%vehicle.maintainAltitudeLevel += %a * 5;
			%client.pushChinookHUD();
		}
		Parent::serverCMDShiftBrick(%client, %a, %b, %c, %d, %e, %f);
	}
};
ActivatePackage(ChinookControls);